class ['a,'b] directory : object
  constraint 'b = < iter : ('a -> unit) -> unit; .. >

  method add_directory : string -> 'b -> unit
  method add_item : string -> 'a -> unit
  method iter : ('a -> unit) -> unit
end

class type ['a] ro_directory = object method iter : ('a -> unit) -> unit end
type 'a dir = ('a, 'a ro_directory) directory

(** Extension with pretty printing *)

class type pretty_printer = object
  method open_section : string -> unit
  method close_section : unit
  method paragraph : string -> unit
end

class terminal_pp : pretty_printer

class ['a,'b] printable_directory : object
  constraint 'a = < to_string : string; .. >
  constraint 'b =
    < iter : ('a -> unit) -> unit; print : pretty_printer -> 'c; .. >
  inherit ['a,'b] directory
  method print : pretty_printer -> unit
end

class type ['a] printable_ro_directory = object
  method iter : ('a -> unit) -> unit
  method print : pretty_printer -> unit
end

type 'a pdir = ('a, 'a printable_ro_directory) printable_directory
  constraint 'a = < to_string : string; .. >

(** Utilities *)
val create_printable_directory : unit -> 'a pdir
